using System;
using System.Threading;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;


namespace ConnectionPool
{

	class WorkerManager
	{
			private const int CLIENTS = 50;

		public ManualResetEvent Wait = new ManualResetEvent(false);

		public void Go()
		{
			ManualResetEvent[] resetEvents = (ManualResetEvent[])Array.CreateInstance(typeof(ManualResetEvent),CLIENTS);

			for(int i = 0;i < CLIENTS;i++)
			{
				Worker w = new Worker();
				Thread t = new Thread(new ThreadStart(w.Go));
				t.Name = "Worker Thread " + i.ToString();
				t.Start();
				resetEvents[i] = w.Wait;
			}
			WaitHandle.WaitAll(resetEvents);
			Wait.Set();
		}
	}

	class Worker
	{
		public ManualResetEvent Wait = new ManualResetEvent(false);

		public void Go()
		{
			try
			{
				for(int i = 0;i < 100;i++)
				{
					using(SqlConnection conn = new SqlConnection("Server=(local);" + 
							  "DataBase=Northwind;"+
							  "Integrated Security=True;"+
							  "Application Name=Advanced ADO.NET Advanced Connection Pooling;"+
							  "Pooling=true;Max Pool Size=25;Min Pool Size=3;"
							  +"Connect timeout = 45;"
							  ))
					{

						conn.Open();
						SqlCommand cmd = new SqlCommand("select @@version", conn);
						string sqlVersion = (string)cmd.ExecuteScalar();
						Trace.WriteLine("From " + Thread.CurrentThread.Name + "\n" + sqlVersion);
						conn.Close();
					}

				}
			}
			catch(System.Exception e)
			{
				throw new System.Exception(e.Message);
			}
			finally
			{
				Wait.Set();
			}
		}
	}
}
