using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Web;
using System.Web.Services;
using System.Data.SqlClient;
using System.EnterpriseServices;

namespace Transactions
{
	/// <summary>
	/// Summary description for Service1.
	/// </summary>
	public class Service1 : System.Web.Services.WebService
	{
		public Service1()
		{
			//CODEGEN: This call is required by the ASP.NET Web Services Designer
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//Required by the Web Services Designer 
		private IContainer components = null;
				
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		// WEB SERVICE EXAMPLE
		// The HelloWorld() example service returns the string Hello World
		// To build, uncomment the following lines then save and build the project
		// To test this web service, press F5

//		[WebMethod]
//		public string HelloWorld()
//		{
//			return "Hello World";
//		}

		[WebMethod(TransactionOption=TransactionOption.Required)]
		public void Transaction()
		{
			//creating a connection with the above WebMethod
			//attribute will cause it to automatically enlist with
			//the DTC in a transaction
			using(SqlConnection conn = new SqlConnection(
					  "Server=(local);DataBase=Northwind;Integrated Security=True"
					  + ";Application Name = Advanced ADO.NET + Cross Database Transactions"
					  + ";Pooling=true;Max Pool Size=5;Min Pool Size = 2"
					  + ";Connect timeout=30;"
					  ))
				  {

				conn.Open();
				SqlCommand cmd = new SqlCommand(
					"insert into TestTransactions(Value) values ('Northwind')", conn);
				cmd.ExecuteNonQuery();
				conn.Close();
			}

			//This connection, even though it's to a different database
			//will enlist in the same transaction as above via the DTC
			using(SqlConnection conn = new SqlConnection(
					  "Server=(local);DataBase=pubs;Integrated Security=True"
					  + ";Application Name = Advanced ADO.NET + Cross Database Transactions"
					  + ";Pooling=true;Max Pool Size=5;Min Pool Size = 2"
					  + ";Connect timeout=30;"
					  ))
				  {
				conn.Open();
				SqlCommand cmd = new SqlCommand(
					"insert into TestTransactions(Value) values ('pubs')", conn);
				cmd.ExecuteNonQuery();
				conn.Close();
			}

			//By setting Enlist=false in the connection string below, this
			//connection will not belong to the above transaction
			using(SqlConnection conn = new SqlConnection(
					  "Server=(local);DataBase=DataBaseCourse;Integrated Security=True"
					  + ";Application Name = Advanced ADO.NET + Cross Database Transactions"
					  + ";Pooling=true;Max Pool Size=5;Min Pool Size = 2"
					  + ";Connect timeout=30;Enlist=false"//will not automatically enlist in transactions
					  ))
				  {
				conn.Open();
				SqlCommand cmd = new SqlCommand(
					"insert into TestTransactions(Value) values ('DataBaseCourse')", conn);
				cmd.ExecuteNonQuery();
				conn.Close();
			}

			//We can cause a connection setup like above to
			//enlist in the running transation using
			//EnlistDistributedTransaction
			using(SqlConnection conn = new SqlConnection(
					  "Server=(local);DataBase=DataBaseCourse;Integrated Security=True"
					  + ";Application Name = Advanced ADO.NET + Cross Database Transactions"
					  + ";Pooling=true;Max Pool Size=5;Min Pool Size = 2"
					  + ";Connect timeout=30;Enlist=false"//will not automatically enlist in transactions
					  ))
				  {
				conn.Open();
				conn.EnlistDistributedTransaction((ITransaction)ContextUtil.Transaction);
				SqlCommand cmd = new SqlCommand(
					"insert into TestTransactions(Value) values ('Enlisted')", conn);
				cmd.ExecuteNonQuery();
				conn.Close();
			}

			//Throwing an exception will cause the transaction to rollback
			throw new System.Web.Services.Protocols.SoapException("We blew up...", 
								System.Web.Services.Protocols.SoapException.ServerFaultCode);
		}

	}
}
